import time
from datetime import datetime
from urllib.parse import urlparse, parse_qs
from http.server import BaseHTTPRequestHandler, HTTPServer

import subprocess

HOST_NAME = 'localhost'
PORT_NUMBER = 4242

class Handler(BaseHTTPRequestHandler):

    def do_HEAD(self):
        self.send_response(200)
        self.send_header('Content-type', 'text/html')
        self.end_headers()

    def do_GET(self):
        self.respond({'status': 200, 'content': "200 - Success"})

    def handle_http(self, status_code, path, content, type="text/html", file=None):
        self.send_response(status_code)
        self.send_header('Content-type', type)
        self.send_header('Cache-Control', 'private, no-cache, no-store, must-revalidate')
        self.send_header('Content-Disposition', 'inline')
        self.end_headers()

    def respond(self, opts):
        self.handle_http(opts['status'], self.path, opts['content'], opts['type'] if 'type' in opts else None, opts['file'] if 'file' in opts else None)
        subprocess.Popen(['./action.sh'])



if __name__ == '__main__':

    server_class = HTTPServer
    httpd = server_class((HOST_NAME, PORT_NUMBER), Handler)
    print(time.asctime(), 'Server Starts - %s:%s' % (HOST_NAME, PORT_NUMBER))
    try:
        httpd.serve_forever()
    except KeyboardInterrupt:
        pass
    httpd.server_close()
    print(time.asctime(), 'Server Stops - %s:%s' % (HOST_NAME, PORT_NUMBER))

