from gluon import *
from parameter_util import B64_TO_JSON
from websocket_util import WEBSOCKET_SEND

def ROOM_GET(_id, _password):
    room_record = current.db(current.db.Room.id == _id).select().first()

    if not room_record:
        return(None)

    if room_record.hashcode != _password:
        return(None)

    return(room_record)


def ROOM_GET_CODE(_code):
    room_record = current.db((current.db.Room.code == _code) & (current.db.Room.closed == False)).select().first()

    return(room_record)

def ROOM_HEARTBEAT(_room):
    current.db(current.db.Room.id == _room.id).update(heartbeat=current.request.now)

def ROOM_CLOSE(_room):
    players = PLAYERS_GET(_room, True)

    current.db(current.db.Room.id == _room.id).update(closed=True, roles="")

    for player in players:
        current.db(current.db.Player.id == player["uid"]).update(name="", prompts="", inputs="")

    #Force reload on clients
    WEBSOCKET_SEND(_room, "reload", "")


def PLAYERS_GET(_room, _uid=False):
    rows = current.db(current.db.Player.room_id == _room.id).select(orderby=current.db.Player.id)

    players = []
    player_id = 0
    for row in rows:
        obj = {"id": player_id, "name": row.name, "role": row.role, "submits": B64_TO_JSON(row.inputs)}
        if _uid:
            obj["uid"] = row.id
        players.append(obj)
        player_id = player_id + 1

    return(players)
